/* 
   Part of Fail-Safe C Runtime. Produced by Yutaka Oiwa.
   (c) 2001-2005 Yutaka Oiwa.
   (c) 2005-2006 AIST.
   (c) 2006	 Lepidum Co. Ltd.

   This file is written by Lepidum Co. Ltd. in 2006.

   This file is distributed under Modified Q Public License.
   See the file LICENSE contained in the distribution.
*/
/**
 * @file stdlib/ioctl.c
 */
#define FSC_RUNTIME_LIBRARY
#include <fsc_runtime.h>
#include <wrapper_helper.h>

#include <stropts.h>
#include <stdio.h>

/**
 * @fn int ioctl(int fd, int req, ...)
 * @param fd file descriptor.
 * @param req function specifier.
 * @param ... request specific arguments.
 *
 * @crashcase unknown
 * @fsctype special
 *
 * @author Lepidum Co., Ltd.
 */
value FS_FiiV_i_ioctl(base_t fd_b, unsigned int fd_o,
                      base_t req_b, unsigned int req_o,
                      base_t va_b, unsigned int va_o)
{
  fprintf(stderr, "ioctl: fd=%d req=%d\n", fd_o, req_o);
  fsc_va_end_base_ofs(va_b, va_o);
  return value_of_int(0);
}
