/* 
   Part of Fail-Safe C Runtime. Produced by Yutaka Oiwa.
   (c) 2001-2005 Yutaka Oiwa.
   (c) 2005-2006 AIST.
   (c) 2006	 Lepidum Co. Ltd.

   This file is written by Lepidum Co. Ltd. in 2006.

   This file is distributed under Modified Q Public License.
   See the file LICENSE contained in the distribution.
*/
/**
 * @file stdlib/unistd/chown.c
 */
#define FSC_RUNTIME_LIBRARY
#include <fsc_runtime.h>
#include <wrapper_helper.h>

#include <unistd.h>


#if 0
/**
 * @fn int fchown(int fd, uid_t owner, gid_t group)
 * @brief set file owner and group.
 * @retval 0 success.
 * @retval -1 fail.
 *
 * @crashcase none
 * @fsctype atomic
 * @todo pid_t != int case
 *
 * @author Lepidum Co., Ltd.
 */
value FS_Fiii_i_fchown(base_t fd_b, int fd_o, base_t owner_b, unsigned int owner_o, base_t group_b, unsigned int group_o)
{
  return value_of_int(fchown(fd_o, owner_o, group_o));
}

#endif

/**
 * @fn int chown(const char *path, uid_t owner, gid_t group)
 * @brief set file owner and group.
 * @retval 0 success.
 * @retval -1 fail.
 *
 * @crashcase none
 * @fsctype string(ro)
 * @todo pid_t != int case
 *
 * @author Lepidum Co., Ltd.
 */
value FS_FPcii_i_chown(base_t path_b, ofs_t path_o,
                       base_t owner_b, unsigned int owner_o,
                       base_t group_b, unsigned int group_o)
{
  void *tmp;
  char *path;
  int ret;

  path = wrapper_get_string_z(path_b, path_o, &tmp, "chown");

  ret = chown(path, owner_o, group_o);

  wrapper_release_tmpbuf(tmp);
  return value_of_int(ret);
}
