/**
 * @file include/_stddef.h
 */
#ifndef ___STDDEF_H
#define ___STDDEF_H

/**
 * @brief signed 8bit integer.
 */
typedef signed char __int8;
/**
 * @brief unsigned 8bit integer.
 */
typedef unsigned char __uint8;

/**
 * @brief signed 16bit integer.
 */
typedef signed short __int16;
/**
 * @brief unsigned 16bit integer.
 */
typedef unsigned short __uint16;

/**
 * @brief signed 32bit integer.
 */
typedef signed int __int32;
/**
 * @brief unsigned 32bit integer.
 */
typedef unsigned int __uint32;

/**
 * @brief signed 64bit integer.
 */
typedef signed long long __int64;
/**
 * @brief unsigned 64bit integer.
 */
typedef unsigned long long __uint64;

/**
 * @brief size of objects.
 */
typedef __uint32 __size_t;
/**
 * @brief size of objects and error indication.
 */
typedef __int32  __ssize_t;
/**
 * @brief difference of two pointers.
 */
typedef __int32  __ptrdiff_t;

/**
 * @brief time counter in processor cycle.
 */
typedef __int32  __clock_t;
/**
 * @brief time counter in seconds.
 */
typedef __int32 __time_t;
/**
 * @brief microseconds.
 */
typedef __uint32 __useconds_t;

/**
 * @brief gid number.
 */
typedef __int32 __gid_t;
/**
 * @brief uid number.
 */
typedef __int32 __uid_t;
/**
 * @brief pid number.
 */
typedef __int32 __pid_t;
/**
 * @brief gid, uid, pid number.
 */
typedef __int32 __id_t;

/**
 * @brief length of sockaddr.
 */
typedef __uint32 __socklen_t;
/**
 * @brief socket addressa family.
 */
typedef __uint16  __sa_family_t;

/**
 * @brief stat structure member.
 */
typedef __int32  __blkcnt_t;
/**
 * @brief stat structure member.
 */
typedef __int32  __blksize_t;
/**
 * @brief stat structure member.
 */
typedef __int32  __dev_t;
/**
 * @brief stat structure member.
 */
typedef __int32  __ino_t;
/**
 * @brief file mode.
 */
typedef __int32  __mode_t;
/**
 * @brief stat structure member.
 */
typedef __int32  __nlink_t;
/**
 * @brief file offset.
 */
typedef __int32  __off_t;

/**
 * @brief limit value.
 */
typedef __int32 __rlim_t;

/**
 * @brief varargs list
 */
typedef int* __va_list;

/**
 * @brief NULL pointer value.
 */
#define __NULL 0

#endif
