/**
 * @file include/netinet/in.h
 */
#ifndef __NETINET_IN_H
#define __NETINET_IN_H

#include <netinet/in_internal.h>
#include <_stddef.h>

/* TODO inttypes.h */
#include <sys/socket.h>

typedef __uint16 in_port_t;
typedef __uint32 in_addr_t;

#define IPPORT_RESERVED 1024

struct __fsc_attribute__((named "stdlib_in_addr")) in_addr {
  in_addr_t s_addr;
};

struct __fsc_attribute__((named "stdlib_sockaddr_in")) sockaddr_in {
  sa_family_t    sin_family;
  in_port_t      sin_port;
  struct in_addr sin_addr;
  char __dummy[8];
};

#define INADDR_ANY 0

extern int __IN_CLASSA(in_addr_t);
extern int __IN_CLASSB(in_addr_t);
extern int __IN_CLASSC(in_addr_t);
extern int __IN_CLASSD(in_addr_t);
extern int __IN_MULTICAST(in_addr_t);
extern int __IN_EXPERIMENTAL(in_addr_t);
extern int __IN_BADCLASS(in_addr_t);

#define IN_CLASSA(a) __IN_CLASSA(a)
#define IN_CLASSB(a) __IN_CLASSB(a)
#define IN_CLASSC(a) __IN_CLASSC(a)
#define IN_CLASSD(a) __IN_CLASSD(a)
#define IN_MULTICAST(a) __IN_MULTICAST(a)
#define IN_EXPERIMENTAL(a) __IN_EXPERIMENTAL(a)
#define IN_BADCLASS(a) __IN_BADCLASS(a)

char *inet_ntoa(struct in_addr);

#endif
