/**
 * @file include/sys/select.h
 */
#ifndef __SYS_SELECT_H
#define __SYS_SELECT_H

#include <memory.h>

#define _FDSET_BYTES (1024 / 8)
#define FD_SETSIZE 1024
#define NFDBITS 8
typedef char fd_mask;

typedef struct __fsc_attribute__((named "stdlib_select_fds")) __select_fds {
    char __fd_set[_FDSET_BYTES];
} fd_set;

struct __fsc_attribute__((named "stdlib_select_timeval")) timeval {
  long tv_sec; long tv_usec;
};

#define FD_ZERO(ps) memset((ps)->__fd_set, 0, _FDSET_BYTES)
#define FD_ISSET(fd,ps) (((ps)->__fd_set[(fd)/8] >> ((fd) % 8)) & 1)
#define FD_CLR(fd,ps) ((ps)->__fd_set[(fd)/8] &= ~(1 << ((fd) % 8)))
#define FD_SET(fd,ps) ((ps)->__fd_set[(fd)/8] |= (1 << ((fd) % 8)))

int select(int n, fd_set *, fd_set *, fd_set *, struct timeval *);

#endif
