#!/usr/bin/perl -w
# -*- perl -*-

use strict;

use FindBin;
use lib "$FindBin::Bin";

our @inttypes;
our @floattypes;
our @includes;
our %types;
require 'types.pl';

$\ = "\n";

print '<%#shared /* -*- c -*- */';

foreach(@includes){
  print "#include <$_>";
}

print '#%>';

print '/* <%=s EC_VERSION_MSG %> */';
print '#include <stdlib.h>';
print '#include <string.h>';

print 'static char *table[][3] = {';

foreach(sort keys %types){
  my $t = $_;
  print '';
  print "/* $t */";

  my %f = map { $_ => 1 } @{$types{$t}};
  my @c;
  if(($f{signed} || !$f{unsigned}) && ($f{integer} || $f{arithmetic})){
    @c = (@c, map { 'signed '.$_} @inttypes);
  }
  if(($f{unsigned} || !$f{signed}) && ($f{integer} || $f{arithmetic})){
    @c = (@c, map { 'unsigned '.$_} @inttypes);
  }
  if(($f{signed} || !$f{unsigned}) && ($f{'floating-point'} || $f{arithmetic})){
    @c = (@c, @floattypes);
  }

  foreach(@c){
    my $s = $_;
    $s =~ s/ /_/g;
    print "<%[[?%><%# $t a; $_ a;#%>{\"$t\", \"$_\", \"$s\"},<%]];%>";
  }
}

print '};';

print <<EOF;

static const char *_conv(const char *t, int us){
  int i;
  for(i = 0; i < sizeof(table)/sizeof(table[0]); i++){
    if(!strcmp(table[i][0], t)){
      return table[i][us ? 2 : 1];
    }
  }
  exit(EXIT_FAILURE);
}

static const char *basetypeof(const char *t){
  return _conv(t, 0);
}

static const char *base_type_of(const char *t){
  return _conv(t, 1);
}
EOF
