sub gen_name {
  my $t = shift;
  my $ut = shift;

  my $k = shift;

  if(!$k){
    "fscw_$ut";
  }elsif($k eq 'read_a' ){
    "fscw_${ut}_read_pointer_param";
  }elsif($k eq 'write_a' ){
    "fscw_${ut}_write_pointer_param";
  }elsif($k eq 'param' || $k eq 'member'){
    "fscw_${ut}_${k}";
  }else{
    "fscw_${ut}_${k}";
  }
}


sub gen_typedef {
  my $t = shift;
  my $ut = shift;

  my $c = shift;

  "typedef $c fscw_$ut;";
}

sub gen_wrap {
  my $t = shift;
  my $ut = shift;

  my $c = shift;

  "FSCW_INLINE fscw_$ut " . &gen_name($t, $ut, 'wrap') . "($t v){ $c }";
}

sub gen_unwrap {
  my $t = shift;
  my $ut = shift;

  my $c = shift;

  "FSCW_INLINE $t " . &gen_name($t, $ut, 'unwrap') . "(fscw_$ut v){ $c }";
}

sub gen_param {
  my $t = shift;
  my $ut = shift;

  my $c = shift;

  "#define " . &gen_name($t, $ut, 'param') . "(n) $c";
}

sub gen_member {
  my $t = shift;
  my $ut = shift;

  my $c = shift;

  "#define " . &gen_name($t, $ut, 'member') . "(t, m) $c";
}

sub gen_read {
  my $t = shift;
  my $ut = shift;

  my $c = shift;

  "FSCW_INLINE fscw_$ut " . &gen_name($t, $ut, 'read') . "(fscw_$ut *p){ $c }";
}

sub gen_write {
  my $t = shift;
  my $ut = shift;

  my $c = shift;

  "FSCW_INLINE void " . &gen_name($t, $ut, 'write') . "(fscw_$ut *p, fscw_$ut v){ $c }";
}

sub gen_read_unwrap {
  my $t = shift;
  my $ut = shift;

  "FSCW_INLINE $t " . &gen_name($t, $ut, 'read_unwrap') . "(fscw_$ut *p){ return fscw_$ut" . "_unwrap(fscw_$ut" . "_read(p)); }";
}

sub gen_wrap_write {
  my $t = shift;
  my $ut = shift;

  "FSCW_INLINE void " . &gen_name($t, $ut, 'wrap_write') . "(fscw_$ut *p, $t v){ fscw_$ut" . "_write(p, fscw_$ut" . "_wrap(v)); }";
}


sub gen_read_a {
  my $t = shift;
  my $ut = shift;

  my $c = shift;

  '#define ' . &gen_name($t, $ut, 'read_a') . "(p, n) $c";
}

sub gen_write_a {
  my $t = shift;
  my $ut = shift;

  my $c = shift;

  '#define ' . &gen_name($t, $ut, 'write_a') . "(p, n, v) $c";
}

1;
