#!/usr/bin/perl -w
# -*- perl -*-

use strict;

use FindBin;
use lib "$FindBin::Bin";

our @inttypes;
our @floattypes;
our @includes;
our %types;
require 'types.pl';
require 'common.pl';

$\ = "\n";

print '<%# /* -*- c -*- */';
print '#include "basetype.c"';
print '#%>';
print '#ifndef __D_ACCESSOR_H';
print '#define __D_ACCESSOR_H';
print '';
print '/* <%=s EC_VERSION_MSG %> */';

foreach(@includes){
  print "#include <$_>";
}

sub fscw_chain {
  my $t = shift;
  my $ut = $t; $ut =~ s/ /_/g;

  my $b = "<%=s basetypeof(\"$t\") %>";
  my $ub = "<%=s base_type_of(\"$t\") %>";

  print &gen_typedef($t, $ut, &gen_name($b, $ub));
  print &gen_wrap   ($t, $ut, 'return ' . &gen_name($b, $ub, 'wrap') . '(v);');
  print &gen_unwrap ($t, $ut, 'return ' . &gen_name($b, $ub, 'unwrap') . '(v);');
  print &gen_param  ($t, $ut, &gen_name($b, $ub, 'param') . '(n)');
  print &gen_member ($t, $ut, &gen_name($b, $ub, 'member') . '(t, m)');
  print &gen_read   ($t, $ut, 'return ' . &gen_name($b, $ub, 'read') . '(p);');
  print &gen_write  ($t, $ut, &gen_name($b, $ub, 'write') . '(p, v);');
  print &gen_read_a ($t, $ut, &gen_name($b, $ub, 'read_a') . '(p, n)');
  print &gen_write_a($t, $ut, &gen_name($b, $ub, 'write_a') . '(p, n, v)');
}

foreach(sort keys %types){
  my $n = $_;

  print '';
  print "/* $n */";
  &fscw_chain($n);
}

print '';
print '#endif /*  __D_ACCESSOR_H */';
