#include <string.h>
#include <stdio.h>
#include <math.h>
#include <float.h>
#include <limits.h>
int main()
{
  int I, J, K;
  int NUM_OF_ARGS = 16;
  int ARGS_PER_CALL = 1;
  int NUM_OF_TESTS = 16;
  char FUNC[] = "jn";
  char TYPE[] = "double";
  int TYPE_SIZE = sizeof(double);
  union {
    double V;
    unsigned char B[sizeof(double)];
  } ARGS[] = {
    0.0,
    -0.0,
    1.0,
    -1.0,
    DBL_MIN,
    -DBL_MIN,
    DBL_MAX,
    -DBL_MAX,
    1.0/0.0,
    -1.0/0.0,
    nan(""),
    -nan(""),
    0.9,
    1.1,
    -0.9,
    -1.1,
  }, ARGS_COPY[1], EXPECTED[64];
  int N[] = { 0, 1, 2, -1};

  for (I = 0; I < NUM_OF_TESTS; ++I) {
    for (K = 0; K < 4; ++K) {
      EXPECTED[I * 4 + K].V = jn(N[K], ARGS[I].V);
	  if (I == 2) {
        EXPECTED[I * 4 + K].V = jn(N[K], ARGS[I].V);
		fprintf(stderr, "EX: %g\n", EXPECTED[I * 4 + K].V);
		fprintf(stderr, "jn: %g\n\n", jn(N[K], ARGS[I].V));
	  }
	}
  }

  printf("/*\n");
  printf("   This file is written by Lepidum Co., Ltd.\n");
  printf("   Copyrignt (c) 2005-2008 by Lepidum Co., Ltd.\n");
  printf(" */\n");
  printf("\n");
  printf("/**\n");
  printf(" * @file math/%s.test.c\n", FUNC);
  printf(" */\n");
  printf("#define _ISOC99_SOURCE\n");
  printf("#include <math.h>\n");
  printf("#include <string.h>\n");
  printf("#include <stdio.h>\n");
  printf("#include <stdlib.h>\n");
  printf("#include <float.h>\n");
  printf("#include \"common.h\"\n");
  printf("\n");
  printf("/**\n");
  printf("  * @testname %s_1\n", FUNC);
  printf("  * @testfor %s\n", FUNC);
  printf("  */\n");
  printf("TEST_CASE(%s_1)\n", FUNC);
  printf("{\n");
  printf("  int i, k;\n");
  printf("  int ok = 1;\n");
  printf("  /* args and expected must be static variables for compile time */\n");
  printf("  static union {\n");
  printf("    unsigned char b[sizeof(%s)];\n", TYPE);
  printf("    %s v;\n", TYPE);
  printf("  } result, args[] = {\n");
  for (I = 0; I < NUM_OF_ARGS; ++I) {
    printf("    {");
    for (J = 0; J < TYPE_SIZE; ++J) {
      printf("0x%02x, ", ARGS[I].B[J]);
    }
    printf("},\n      /* %e */\n", ARGS[I].V);
  }
  printf("  }, expected[] = {\n");
  for (I = 0; I < 64; ++I) {
    printf("    {");
    for (J = 0; J < TYPE_SIZE; ++J) {
      printf("0x%02x, ", EXPECTED[I].B[J]);
    }
    printf("},\n");
    printf("      /* %e */\n", EXPECTED[I].V);
  }
  printf("  };\n");
  printf("  int n[] = { 0, 1, 2, -1, };\n");
  printf("\n");
  printf("  for (i = 0; i < %d; ++i) {\n", NUM_OF_TESTS);
  printf("  for (k = 0; k < 4; ++k) {\n");
  printf("    result.v = %s( n[k],", FUNC);
  for (I = 0; I < ARGS_PER_CALL; ++I) {
    printf("args[i * %d + %d].v", ARGS_PER_CALL, I);
    if (I + 1 < ARGS_PER_CALL) {
      printf(",");
    }
  }
  printf(");\n");
  printf("    if (memcmp(result.b, expected[i * 4 + k].b, sizeof(%s)) != 0) {\n", TYPE);
  printf("      int j;\n");
  printf("      fprintf(stderr, \"\\n%%d, %%d\\nreturned: \", i, k);\n");
  printf("      for (j = 0; j < sizeof(%s); ++j) {\n", TYPE);
  printf("        fprintf(stderr, \"%%02x, \", result.b[j]);\n");
  printf("      }\n");
  printf("      fprintf(stderr, \"(%%e)\\n\", result.v);\n");
  printf("      fprintf(stderr, \"expected: \");\n");
  printf("      for (j = 0; j < sizeof(%s); ++j) {\n", TYPE);
  printf("        fprintf(stderr, \"%%02x, \", expected[i * 4 + k].b[j]);\n");
  printf("      }\n");
  printf("      fprintf(stderr, \"(%%e)\\n\", expected[i * 4 + k].v);\n");
  printf("      ok = 0;\n");
  printf("    }\n");
  printf("  }\n}\n");
  printf("\n");
  printf("  TEST(ok);\n");
  printf("}\n");

  return 0;
}
