
#include <stdio.h>
#include <math.h>
#include <float.h>
int main()
{
  int I, J;
  int NUM_OF_ARGS = 16;
  int ARGS_PER_CALL = 1;
  int NUM_OF_TESTS = 16;
  char FUNC[] = "lgammaf";
  char TYPE[] = "float";
  int TYPE_SIZE = sizeof(float);
  union {
    float V;
    unsigned char B[sizeof(float)];
  } ARGS[] = {
    0.0f,
    -0.0f,
    1.0,
    -1.0,
    FLT_MIN,
    -FLT_MIN,
    FLT_MAX,
    -FLT_MAX,
    1.0f/0.0f,
    -1.0f/0.0f,
    nanf(""),
    -nanf(""),
    0.9f,
    1.1f,
    -0.9f,
    -1.1f,
  }, ARGS_COPY[1], EXPECTED[16];
  int EXPECTED_SIGNGAM[16];

  for (I = 0; I < NUM_OF_TESTS; ++I) {
    EXPECTED[I].V = lgammaf(
      ARGS[I * ARGS_PER_CALL + 0].V
    );
    EXPECTED_SIGNGAM[I] = signgam;
  }

  printf("/*\n");
  printf("   This file is written by Lepidum Co., Ltd.\n");
  printf("   Copyrignt (c) 2005-2008 by Lepidum Co., Ltd.\n");
  printf(" */\n");
  printf("\n");
  printf("/**\n");
  printf(" * @file math/%s.test.c\n", FUNC);
  printf(" */\n");
  printf("#define _ISOC99_SOURCE\n");
  printf("#include <math.h>\n");
  printf("#include <string.h>\n");
  printf("#include <stdio.h>\n");
  printf("#include <stdlib.h>\n");
  printf("#include <float.h>\n");
  printf("#include \"common.h\"\n");
  printf("\n");
  printf("/**\n");
  printf("  * @testname %s_1\n", FUNC);
  printf("  * @testfor %s\n", FUNC);
  printf("  */\n");
  printf("TEST_CASE(%s_1)\n", FUNC);
  printf("{\n");
  printf("  int i;\n");
  printf("  int ok = 1;\n");
  printf("  /* args and expected must be static variables for compile time */\n");
  printf("  static union {\n");
  printf("    unsigned char b[sizeof(%s)];\n", TYPE);
  printf("    %s v;\n", TYPE);
  printf("  } result, args[] = {\n");
  for (I = 0; I < NUM_OF_ARGS; ++I) {
    printf("    {");
    for (J = 0; J < TYPE_SIZE; ++J) {
      printf("0x%02x, ", ARGS[I].B[J]);
    }
    printf("},\n      /* %e */\n", ARGS[I].V);
  }
  printf("  }, expected[] = {\n");
  for (I = 0; I < NUM_OF_TESTS; ++I) {
    printf("    {");
    for (J = 0; J < TYPE_SIZE; ++J) {
      printf("0x%02x, ", EXPECTED[I].B[J]);
    }
    printf("},\n");
    printf("      /* %e */\n", EXPECTED[I].V);
  }
  printf("  };\n");
  printf("  int expected_signgam[] = {\n");
  for (I = 0; I < NUM_OF_TESTS; ++I) {
    printf("    %d,\n", EXPECTED_SIGNGAM[I]);
  }
  printf("  };\n");
  printf("\n");
  printf("  for (i = 0; i < %d; ++i) {\n", NUM_OF_TESTS);
  printf("    result.v = %s( ", FUNC);
  for (I = 0; I < ARGS_PER_CALL; ++I) {
    printf("args[i * %d + %d].v", ARGS_PER_CALL, I);
    if (I + 1 < ARGS_PER_CALL) {
      printf(",");
    }
  }
  printf(");\n");
  printf("    if (memcmp(result.b, expected[i].b, sizeof(%s)) != 0) {\n", TYPE);
  printf("      int j;\n");
  printf("      fprintf(stderr, \"\\nreturned: \");\n");
  printf("      for (j = 0; j < sizeof(%s); ++j) {\n", TYPE);
  printf("        fprintf(stderr, \"%%02x, \", result.b[j]);\n");
  printf("      }\n");
  printf("      fprintf(stderr, \"(%%e)\\n\", result.v);\n");
  printf("      fprintf(stderr, \"expected: \");\n");
  printf("      for (j = 0; j < sizeof(%s); ++j) {\n", TYPE);
  printf("        fprintf(stderr, \"%%02x, \", expected[i].b[j]);\n");
  printf("      }\n");
  printf("      fprintf(stderr, \"(%%e)\\n\", expected[i].v);\n");
  printf("      ok = 0;\n");
  printf("    } else if (signgam != expected_signgam[i]) {\n");
  printf("      fprintf(stderr, \"\\nreturned: %%d\\n\", signgam);\n");
  printf("      fprintf(stderr, \"expected: %%d\\n\", expected_signgam[i]);\n");
   printf("    }\n");
  printf("  }\n");
  printf("\n");
  printf("  TEST(ok);\n");
  printf("}\n");

  return 0;
}
