
#include <stdio.h>
#include <math.h>
#include <float.h>
#include <limits.h>
int main()
{
  int I, J;
  int NUM_OF_ARGS = 20;
  int ARGS_PER_CALL = 1;
  int NUM_OF_TESTS = 20;
  char FUNC[] = "llrint";
  char TYPE[] = "double";
  int TYPE_SIZE = sizeof(double);
  union {
    double V;
    unsigned char B[sizeof(double)];
  } ARGS[] = {
    9223372036854773760.0,
    -9223372036854775808.0,
    0.0,
    -0.0,
    1.0,
    -1.0,
    DBL_MIN,
    -DBL_MIN,
    0.5,
    -0.5,
    0.5*M_PI,
    M_PI,
    1.5*M_PI,
    2.0*M_PI,
    -0.5*M_PI,
    -1.0*M_PI,
    -1.5*M_PI,
    -2.0*M_PI,
    0.25*M_PI,
    -0.25*M_PI,
  }, ARGS_COPY[1];
  long long EXPECTED[20];

  for (I = 0; I < NUM_OF_TESTS; ++I) {
    EXPECTED[I] = llrint(
      ARGS[I * ARGS_PER_CALL + 0].V
    );
  }

  printf("/*\n");
  printf("   This file is written by Lepidum Co., Ltd.\n");
  printf("   Copyrignt (c) 2005-2008 by Lepidum Co., Ltd.\n");
  printf(" */\n");
  printf("\n");
  printf("/**\n");
  printf(" * @file math/%s.test.c\n", FUNC);
  printf(" */\n");
  printf("#define _ISOC99_SOURCE\n");
  printf("#include <math.h>\n");
  printf("#include <string.h>\n");
  printf("#include <stdio.h>\n");
  printf("#include <stdlib.h>\n");
  printf("#include <float.h>\n");
  printf("#include \"common.h\"\n");
  printf("\n");
  printf("/**\n");
  printf("  * @testname %s_1\n", FUNC);
  printf("  * @testfor %s\n", FUNC);
  printf("  */\n");
  printf("TEST_CASE(%s_1)\n", FUNC);
  printf("{\n");
  printf("  int i;\n");
  printf("  int ok = 1;\n");
  printf("  /* args and expected must be static variables for compile time */\n");
  printf("  static union {\n");
  printf("    unsigned char b[sizeof(%s)];\n", TYPE);
  printf("    %s v;\n", TYPE);
  printf("  } args[] = {\n");
  for (I = 0; I < NUM_OF_ARGS; ++I) {
    printf("    {");
    for (J = 0; J < TYPE_SIZE; ++J) {
      printf("0x%02x, ", ARGS[I].B[J]);
    }
    printf("},\n      /* %e */\n", ARGS[I].V);
  }
  printf("  };\n");
  printf("  long long expected[] = {\n");
  for (I = 0; I < NUM_OF_TESTS; ++I) {
    printf("    %lldLL,\n", EXPECTED[I]);
  }
  printf("  };\n");
  printf("  long long result;\n");
  printf("\n");
  printf("  for (i = 0; i < %d; ++i) {\n", NUM_OF_TESTS);
  printf("    result = %s( ", FUNC);
  for (I = 0; I < ARGS_PER_CALL; ++I) {
    printf("args[i * %d + %d].v", ARGS_PER_CALL, I);
    if (I + 1 < ARGS_PER_CALL) {
      printf(",");
    }
  }
  printf(");\n");
  printf("    if (result != expected[i]) {\n", TYPE);
  printf("      fprintf(stderr, \"\\nreturned: %%lld\\n\", result);\n");
  printf("      fprintf(stderr, \"expected: %%lld\\n\", expected[i]);\n");
  printf("      ok = 0;\n");
  printf("    }\n");
  printf("  }\n");
  printf("\n");
  printf("  TEST(ok);\n");
  printf("}\n");

  return 0;
}
