#!/bin/sh
# ./mathtestgen_mgr.sh <type> <function> <args_per_call> <argument>...

FLT_BOUNDARIES='0.0f -0.0f 1.0 -1.0 FLT_MIN -FLT_MIN FLT_MAX -FLT_MAX 1.0f/0.0f -1.0f/0.0f nanf("") -nanf("")'
FLT_X_PI='(float)(0.5*M_PI) (float)M_PI (float)(1.5*M_PI) (float)(2.0*M_PI) (float)(-0.5*M_PI) (float)(-1.0*M_PI) (float)(-1.5*M_PI) (float)(-2.0*M_PI) (float)(0.25*M_PI) (float)(-0.25*M_PI)'
FLT_AROUND_1='0.9f 1.1f -0.9f -1.1f'

DBL_BOUNDARIES='0.0 -0.0 1.0 -1.0 DBL_MIN -DBL_MIN DBL_MAX -DBL_MAX 1.0/0.0 -1.0/0.0 nan("") -nan("")'
DBL_X_PI='0.5*M_PI M_PI 1.5*M_PI 2.0*M_PI -0.5*M_PI -1.0*M_PI -1.5*M_PI -2.0*M_PI 0.25*M_PI  -0.25*M_PI'
DBL_AROUND_1='0.9 1.1 -0.9 -1.1'

#./mathtestgen_mgr.sh double sin 1 $DBL_BOUNDARIES

./mathtestgen_mgr.sh double acos      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double acosh     1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double asin      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double asinh     1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double atan      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double atanh     1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double cbrt      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double ceil      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double cos       1 $DBL_BOUNDARIES $DBL_X_PI
./mathtestgen_mgr.sh double cosh      1 $DBL_BOUNDARIES $DBL_X_PI
./mathtestgen_mgr.sh double erfc      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double erf       1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double exp2      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double exp       1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double expm1     1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double fabs      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double floor     1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double j0        1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double j1        1 $DBL_BOUNDARIES $DBL_AROUND_1
#./mathtestgen_mgr.sh double lgamma    1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double log10     1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double log1p     1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double log2      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double logb      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double log       1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double nearbyint 1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double rint      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double round     1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double sin       1 $DBL_BOUNDARIES $DBL_X_PI
./mathtestgen_mgr.sh double sinh      1 $DBL_BOUNDARIES $DBL_X_PI
./mathtestgen_mgr.sh double sqrt      1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double tan       1 $DBL_BOUNDARIES $DBL_X_PI
./mathtestgen_mgr.sh double tanh      1 $DBL_BOUNDARIES $DBL_X_PI
./mathtestgen_mgr.sh double tgamma    1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double trunc     1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double y0        1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh double y1        1 $DBL_BOUNDARIES $DBL_AROUND_1
./mathtestgen_mgr.sh float acosf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float acoshf     1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float asinf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float asinhf     1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float atanf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float atanhf     1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float cbrtf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float ceilf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float cosf       1 $FLT_BOUNDARIES $FLT_X_PI
./mathtestgen_mgr.sh float coshf      1 $FLT_BOUNDARIES $FLT_X_PI
./mathtestgen_mgr.sh float erfcf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float erff       1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float exp2f      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float expf       1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float expm1f     1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float fabsf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float floorf     1 $FLT_BOUNDARIES $FLT_AROUND_1
#./mathtestgen_mgr.sh float lgammaf 1 $FLT_BOUNDARIES $FLT_RANDS
./mathtestgen_mgr.sh float log10f     1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float log1pf     1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float log2f      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float logbf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float logf       1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float nearbyintf 1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float rintf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float roundf     1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float sinf       1 $FLT_BOUNDARIES $FLT_X_PI
./mathtestgen_mgr.sh float sinhf      1 $FLT_BOUNDARIES $FLT_X_PI
./mathtestgen_mgr.sh float sqrtf      1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float tanf       1 $FLT_BOUNDARIES $FLT_X_PI
./mathtestgen_mgr.sh float tanhf      1 $FLT_BOUNDARIES $FLT_X_PI
./mathtestgen_mgr.sh float tgammaf    1 $FLT_BOUNDARIES $FLT_AROUND_1
./mathtestgen_mgr.sh float truncf     1 $FLT_BOUNDARIES $FLT_AROUND_1
