#!/bin/sh
# ./mathtestgen_mgr.sh <type> <function> <args_per_call> <argument>...

FLT_BOUNDARIES='0.0f -0.0f 1.0 -1.0 FLT_MIN -FLT_MIN FLT_MAX -FLT_MAX 1.0f/0.0f -1.0f/0.0f nanf("") -nanf("")'
FLT_X_PI='(float)(0.5*M_PI) (float)M_PI (float)(1.5*M_PI) (float)(2.0*M_PI) (float)(-0.5*M_PI) (float)(-1.0*M_PI) (float)(-1.5*M_PI) (float)(-2.0*M_PI) (float)(0.25*M_PI) (float)(-0.25*M_PI)'
FLT_AROUND_1='0.9f 1.1f -0.9f -1.1f'

FLT_ARGS=""
for arg1 in $FLT_BOUNDARIES $FLT_AROUND_1
do
  for arg2 in $FLT_BOUNDARIES $FLT_AROUND_1
  do
    FLT_ARGS=$FLT_ARGS" ""$arg1"" ""$arg2"
  done
done


DBL_BOUNDARIES='0.0 -0.0 1.0 -1.0 DBL_MIN -DBL_MIN DBL_MAX -DBL_MAX 1.0/0.0 -1.0/0.0 nan("") -nan("")'
DBL_X_PI='0.5*M_PI M_PI 1.5*M_PI 2.0*M_PI -0.5*M_PI -1.0*M_PI -1.5*M_PI -2.0*M_PI 0.25*M_PI  -0.25*M_PI'
DBL_AROUND_1='0.9 1.1 -0.9 -1.1'

DBL_ARGS=""
for arg1 in $DBL_BOUNDARIES $DBL_AROUND_1
do
  for arg2 in $DBL_BOUNDARIES $DBL_AROUND_1
  do
    DBL_ARGS=$DBL_ARGS" ""$arg1"" ""$arg2"
  done
done


./mathtestgen_mgr.sh double atan2     2 $DBL_ARGS
./mathtestgen_mgr.sh double copysign  2 $DBL_ARGS
./mathtestgen_mgr.sh double fdim      2 $DBL_ARGS
./mathtestgen_mgr.sh double fmax      2 $DBL_ARGS
./mathtestgen_mgr.sh double fmin      2 $DBL_ARGS
./mathtestgen_mgr.sh double fmod      2 $DBL_ARGS
./mathtestgen_mgr.sh double hypot     2 $DBL_ARGS
./mathtestgen_mgr.sh double nextafter 2 $DBL_ARGS
./mathtestgen_mgr.sh double pow       2 $DBL_ARGS
./mathtestgen_mgr.sh double remainder 2 $DBL_ARGS
./mathtestgen_mgr.sh double scalb     2 $DBL_ARGS
./mathtestgen_mgr.sh float atan2f     2 $FLT_ARGS 
./mathtestgen_mgr.sh float copysignf  2 $FLT_ARGS
./mathtestgen_mgr.sh float fdimf      2 $FLT_ARGS
./mathtestgen_mgr.sh float fmaxf      2 $FLT_ARGS
./mathtestgen_mgr.sh float fminf      2 $FLT_ARGS
./mathtestgen_mgr.sh float fmodf      2 $FLT_ARGS
./mathtestgen_mgr.sh float hypotf     2 $FLT_ARGS
./mathtestgen_mgr.sh float nextafterf 2 $FLT_ARGS
./mathtestgen_mgr.sh float powf       2 $FLT_ARGS
./mathtestgen_mgr.sh float remainderf 2 $FLT_ARGS

#double  fma (double x, double y, double z)
#float   fmaf (float x, float y, float z)
