/*
   This file is written by Lepidum Co., Ltd.
   Copyright (c) 2005-2006 by Lepidum Co., Ltd.
 */

/**
 * @file net/inet.test.c
 */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "common.h"
#include <string.h>

/**
 * @testname inet_addr_1
 * @testfor inet_addr
 */
TEST_CASE(inet_addr_1)
{
  in_addr_t t = -1;
  in_addr_t v = inet_addr("");
  TEST(t == v);
}

/**
 * @testname inet_addr_2
 * @testfor inet_addr
 */
TEST_CASE(inet_addr_2)
{
  in_addr_t t = 0x0100007F;
  in_addr_t v = inet_addr("127.0.0.1");
  TEST(t == v);
}

/**
 * @testname inet_addr_3
 * @testfor inet_addr
 */
TEST_CASE(inet_addr_3)
{
  in_addr_t t = -1;
  in_addr_t v = inet_addr("0xFF.0xFF.0xFF.0xFF");
  TEST(t == v);
}

/**
 * @testname inet_ntoa_1
 * @testfor inet_ntoa
 */
TEST_CASE(inet_ntoa_1)
{
  struct in_addr t = {0x00000000};
  char *p = inet_ntoa(t);
  TEST(strcmp(p, "0.0.0.0") == 0);
}

/**
 * @testname inet_ntoa_2
 * @testfor inet_ntoa
 */
TEST_CASE(inet_ntoa_2)
{
  struct in_addr t = {0x0100007f};
  char *p = inet_ntoa(t);
  TEST(strcmp(p, "127.0.0.1") == 0);
}

/**
 * @testname inet_ntoa_3
 * @testfor inet_ntoa
 */
TEST_CASE(inet_ntoa_3)
{
  struct in_addr t = {0xffffffff};
  char *p = inet_ntoa(t);
  TEST(strcmp(p, "255.255.255.255") == 0);
}
