/*
   This file is written by Lepidum Co., Ltd.
   Copyright (c) 2005-2006 by Lepidum Co., Ltd.
 */

/**
 * @file unix/locale.test.c
 */
#include <locale.h>
#include <string.h>
#include <stdio.h>
#include "common.h"

/**
 * @testname setlocale_1
 * @testfor setlocale
 */
TEST_CASE(setlocale_1)
{
  char *r;

  setlocale(LC_ALL, ""); /* environ set locale to C */
  r = setlocale(LC_ALL, NULL);
  TEST_FAIL_IF(r == NULL);
  TEST_FAIL_IF(strcmp(r, "C") != 0 && strcmp(r, "POSIX") != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_ALL, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_COLLATE, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_CTYPE, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_MESSAGES, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_MONETARY, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_NUMERIC, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_TIME, NULL), r) != 0);

  setlocale(LC_ALL, "POSIX");
  r = setlocale(LC_ALL, NULL);
  TEST_FAIL_IF(r == NULL);
  TEST_FAIL_IF(strcmp(r, "C") != 0 && strcmp(r, "POSIX") != 0); /* POSIX may be an alias to C */
  TEST_FAIL_IF(strcmp(setlocale(LC_ALL, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_COLLATE, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_CTYPE, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_MESSAGES, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_MONETARY, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_NUMERIC, NULL), r) != 0);
  TEST_FAIL_IF(strcmp(setlocale(LC_TIME, NULL), r) != 0);
  TEST(1);
}

